#!/bin/bash

. /usr/local/Reductor/etc/const

mkdir -p $CACHEDIR/ipset.save.snapshots/
mkdir -p $CACHEDIR/signatures.cache.snapshots/
mkdir -p $CACHEDIR/https_resolv.snapshots/

ipset save | gzip -c - > "$CACHEDIR/ipset.save.snapshots/ipset.save.$(date +%H).gz"

if [ -f $CACHEDIR/signatures.cache ]; then
	gzip -c $CACHEDIR/signatures.cache > "$CACHEDIR/signatures.cache.snapshots/signatures.cache.$(date +%H).gz"
fi

if [ -f $CACHEDIR/https_resolv.json ]; then
	gzip -c $CACHEDIR/https_resolv.json > "$CACHEDIR/https_resolv.snapshots/https_resolv.json.$(date +%H).gz"
fi

for dir in ipset.save signatures.cache https_resolv; do
	find $CACHEDIR/$dir.snapshots/ -type f -name "*.[0-9]" -delete
	find $CACHEDIR/$dir.snapshots/ -type f -name "*.[0-9][0-9]" -delete
done
