#!/bin/bash

. /usr/local/Reductor/etc/const

date="$(date +%s)"
date_begin=1470294548
date_end=$((1470294548 + (24*60*60*2))) # 2 days
influxdb="http://public-influxdb.carbonsoft.ru"
auth="lists_loader:lists_loader_pass"
if [ "$date" -lt "$date_begin" -o "$date" -gt "$date_end" ]; then
	exit 0
fi
regnum="$($BINDIR/reg_util create)"

lists() {
	cd $LISTDIR
	for i in rkn.* *.load; do
		wc -l $i
	done | while read size list; do
		echo "$date $list $size"
		curl -sSL -u $auth "$influxdb/write?db=lists" -d "$list,regnum=$regnum value=$size"
		sleep $((RANDOM % 2))
	done
}

load() {
	url_load="$(grep URL $PROCLIST  | egrep -o '[0-9]+')"
	dns_load="$(grep Domains /proc/net/ipt_dnsmatch/block_list | egrep -o '[0-9]+')"

	echo $date url_load $url_load
	curl -sSL -u $auth "$influxdb/write?db=lists" -d "url_load,regnum=$regnum value=$url_load"
	echo $date dns_load $dns_load
	curl -sSL -u $auth "$influxdb/write?db=lists" -d "dns_load,regnum=$regnum value=$dns_load"
}

check_url_count() {
	if [ ! -f $LISTDIR/rkn.list ]; then
		return 0
	fi
	count="$(wc -l < $LISTDIR/rkn.list)"
	count_real="$(grep ^URL $PROCLIST | egrep -o [0-9]+)"
	[ "$count_real" -gt "$((count))" ]
	rc=$?
	echo $date check_url_count $rc
	curl -sSL -u $auth "$influxdb/write?db=lists" -d "check_url_count,regnum=$regnum value=$rc"
	echo
}

lists
load
check_url_count
