#!/usr/bin/env bash

. /usr/local/Reductor/etc/const
# shellcheck disable=SC1090
. $CONFIG

set -eu

main() {
	local prefix="$1"
	local prefix_type
	if [ "$prefix" = 'ip_port' ]; then
		prefix_type="$prefix"
	elif [ "$prefix" != "${prefix//url/}" ]; then
		prefix_type="url"
	elif [ "$prefix" != "${prefix//domain/}" ]; then
		prefix_type="domain"
	elif [ "$prefix" != "${prefix//ip/}" ]; then
		prefix_type="ip"
	elif [ "$prefix" != "${prefix//port/}" ]; then
		prefix_type="port"
	else
		echo "ERROR: Unknown prefix $prefix"
		return 1
	fi
	$BINDIR/normalize_$prefix_type.sh $prefix
}

main "$@"
