#!/bin/bash

. /usr/local/Reductor/etc/const
. $CONFIG
. $MENULIB

set -eu

trap __exit EXIT
debug=0

log "DEPRECATED" >> $LOGFILE

do_cmd() {
	local cmd="$1"
	case "${cmd%% *}" in
	check_regnumber )
		__log "call $BINDIR/reg_check.sh"
		$BINDIR/reg_check.sh > $TMPFILE
		;;
	get_regnumber )
		__log "call $BINDIR/reg_get.sh"
		$BINDIR/reg_get.sh > $TMPFILE
		;;
	setregnum )
		__log "set_regnum ${cmd##* }"
		set_regnum "${cmd##* }"
		;;
	autonomouse_mode )
		__log "gonna autonomouse_mode"
		$BINDIR/renew_actcode.sh
		$BINDIR/load.sh
		;;
	run_update )
		__log "call $BINDIR/load.sh"
		$BINDIR/renew_actcode.sh
		$BINDIR/load.sh
		exit 0
		;;
	warning )
		local get_regnumber="Настройте обновление списков в menu."
		warning ${initial//get_regnumber/$get_regnumber}
		;;
	* )
		warning "no handler for $cmd"
		;;
	esac
}

set_regnum() {
	reg['regnumber']="$1"
	reg['installcode']="$(get_reductor_instcode)"
	save_and_exit
}

__log() {
	[ "$debug" = '1' ] && log $@
	log $@ >> $LOGFILE
}

auto=1
mkdir -p $TMPDIR
TMPFILE=$TMPDIR/reg_initial.sh
is_module_loaded
check_connect
for i in {1..2}; do
	$BINDIR/reg_initial.sh > $TMPFILE || true
	read initial < $TMPFILE
	do_cmd "$initial"
	if [ "$initial" == 'autonomouse_mode' ]; then
		break
	fi
	read postinitial < $TMPFILE
	do_cmd "$postinitial"
	rm -f $TMPFILE
done
