#!/bin/bash

. /usr/local/Reductor/etc/const
. $CONFIG
. $MENULIB

log "DEPRECATED" >> $LOGFILE

export auto=1
no_inet=0
is_module_loaded || __terminate 'Модуль Carbon Reductor не загружен!'
if ! check_connect; then
	no_inet=1
fi

reg['installcode']="$(get_reductor_instcode)"
params="$(get_reg_params)"
mkdir -p $TMPDIR
__LOGFILE=$LOGDIR/$(basename $0).log

get_new_actcode() {
	if ! curl -sS "$URI" 2>>$__LOGFILE > $TMPDIR/actcode; then
		echo "$(date) access error" >> $__LOGFILE
		nslookup docs.carbonsoft.ru >> $__LOGFILE
	fi
	if grep -qv '^[0-9.-]*$' $TMPDIR/actcode; then
		echo "$(date) actcode error" >> $__LOGFILE
		echo ${reg['actcode']}
	else
		cat $TMPDIR/actcode
	fi
}

write2conf() {
	reg['actcode']="$1"
	save_and_exit
}

write2proc() {
	if ! echo "unlock_$1" > $PROCLIST; then
		echo "$(date) activate error ($1)" >> $__LOGFILE
		return 1
	fi
}

try_activate() {
	new_actcode="$(get_new_actcode)"
	[ "$no_inet" = '1' ] && write2proc ${reg['actcode']} && return 0
	if [ -n "$new_actcode" ]; then
		if [ "$new_actcode" != "${reg['actcode']}" ]; then
			write2conf $new_actcode
		fi
		write2proc $new_actcode || return 1
	else
		write2proc ${reg['actcode']} || return 1
	fi
}

main() {
	for url in ${autoupdate['url']}; do
		URI="$url/renew_actcode.php?$params"
		try_activate "$URI" && break
	done
}

main "$@"
