#!/usr/bin/python
#coding:utf8

import os, sys, urllib, urllib2, base64
from carbon_reductor_reg import reg_number_from_file, reg_file_read


def str2base64(s, unknown=True, encode=True):
    if not s and unknown == True:
        s = 'Unknown'
    if encode == True:
        s = s.encode('utf-8')
    return base64.encodestring(s).replace('+', '_')


def get_params():
    hookdir = '/usr/local/Reductor/userinfo/hooks/'
    reg_data = reg_file_read()

    if not reg_data:
        print 'No reg data to use monitoring system'
        exit(1)

    os.chdir(hookdir)
    params = {
        'result': sys.argv[1],
        'company': str2base64(reg_data['CRB-Reductor']['company_name']),
        'email': str2base64(reg_data['CRB-Reductor']['email']),
        'regnumber': reg_number_from_file(),
        'hooks': str2base64(' '.join(filter(os.path.isfile, os.listdir(hookdir))), unknown=False)
    }

    if not params['regnumber']:
        print 'No regnumber to use monitoring system'
        exit(2)

    with open('/usr/local/Reductor/etc/version') as f:
        params['version'] = f.read().strip()
    with open('/opt/reductor_web/app/var/errors') as f:
        params['output'] = str2base64(f.read(), unknown=False, encode=False)
    with open('/tmp/reductor/support_info') as f:
        params['config'] = str2base64(f.read(), unknown=False, encode=False)

    return params

def send_params(params):
    url = "http://reductor.carbonsoft.ru:8085"
    encoded_params = urllib.urlencode(params)
    try:
        output = urllib2.urlopen(url, data=encoded_params)
    except urllib2.URLError:
        print "monitoring server unreachable"
        exit(1)
    print output.read().strip()


send_params(get_params())
