#!/bin/bash

. /usr/local/Reductor/etc/const
# shellcheck disable=SC1090
. $BINDIR/setup_gui_lib.sh
# shellcheck disable=SC1090
. $BINDIR/setup_network_lib.sh

cleanup() {
	rm -f $TMPDIR/mirror_device
	if [ -f $USERDIR/mirror_info.conf ]; then
		mv -f $USERDIR/mirror_info.conf{,.bk}
	fi
}

main() {
	mirror_info_for_up_interfaces
	ask_about_setup || terminate "$NETWORK_SETUP_LINK"
	cleanup
	select_mirror_type 2>$TMPDIR/mirror_type
	read mirror_type < $TMPDIR/mirror_type
	if ! [[ "$mirror_type" =~ (l2_vlan_only|l2_vlan_mixed|l2_eth_only|l3|l3_vlan) ]]; then
		terminate "Надо было выбрать тип зеркала трафика"
	fi
	$mirror_type
	sort -u $USERDIR/mirror_info.conf > $USERDIR/mirror_info.conf.tmp
	mv -f $USERDIR/mirror_info.conf{.tmp,}
	$BINDIR/setup_network_gen.sh
	! ask "Применить новые настройки сети?" || /etc/init.d/network restart
}

${1:-main}
