#!/bin/bash

. /usr/local/Reductor/etc/const
. $CONFIG

file=$TMPDIR/${0##*/}.$$

line2list() {
	sed -e 's/^/\n/g'
}

cert_date() {
	finish="$(/usr/local/Reductor/bin/check_cert_date auto | grep notAfter | cut -d '=' -f2)"
	echo $((($(date +%s --date="$finish") - $(date +%s))/86400))
}

reg_info() {
	echo "## Информация о регистрации"
	$BINDIR/reg_util info | line2list
}

gen_stat() {
	echo "## Текущее время: "
	date
	echo
	echo "## Статистика модуля фильтрации HTTP:"
	$BINDIR/modules_ctl info ipt_reductor | line2list
	echo
	echo "## Статистика модуля фильтрации DNS:"
	$BINDIR/modules_ctl info ipt_dnsmatch | line2list
	echo
	echo "## Статистика модуля фильтрации SNI:"
	$BINDIR/modules_ctl info ipt_snimatch | line2list
	echo
	echo "## Информация о списках:"
	echo "Список РКН:"
	echo -n "Версия от: "
	$BINDIR/rkn_info.sh --rkn-update-time
	echo
	echo "Остальные списки:"
	ls -la $LISTDIR/*.load $LISTDIR/rkn.* $LISTDIR/*.list $LISTDIR/*.iplist $LISTDIR/*.ipblock $LISTDIR/*.httpslist $LISTDIR/*.*white*list $DUMPXML $SSLDIR/php/register.zip 2>/dev/null | sed -E 's/.*root\s*[0-9]+//g' | while read line; do echo "$line"; done | sort -u | line2list
	echo
	echo "## Информация о сертификате"
	if [ ! -s "$PRIVATE_KEY" ]; then
		echo "Сертификат отсутствует"
	else
		cert_date="$(cert_date)"
		if [ "$cert_date" -gt 0 ]; then
			echo "Сертификат действителен ещё $(cert_date) дней"
		else
			echo "Сертификат просрочен"
		fi
	fi
	echo
	reg_info
	echo
	$BINDIR/rpminfo
}

main() {
	gen_stat > $file
	show_file $file
	rm -f $file
}

use_hook() {
	hook="$HOOKDIR/${0##*/}"
	if [ -x "$hook" ]; then
		. "$hook"
	fi
}

use_hook


${1:-main}
