#!/usr/bin/python -u
# coding: utf-8

u"""Скрипт подготавливающий домены к загрузке в dnsmatch"""

from os import path
from re import match
from sys import stdin, argv


IP_REGEX = '^([0-9]{1,3}\.){3}[0-9]{1,3}$'

def dnsify(domain):
    u"""Возвращает байтовую строку в HEX"""
    try:
        return  domain.strip().decode('utf-8').encode('idna')
    except:
        raise Exception(domain)


def process_domain(domain, list_id):
    u"""перекодирование и скармливание домена dnsify"""
    print "{0} {1}".format(list_id, dnsify(domain))


def process_domain_list(filename=stdin, list_id=0):
    u"""Конвертит и печатает строки из файла, рулит www."""
    for line in filename.xreadlines():
        if match(IP_REGEX, line):
            continue
        if line.startswith('www.'):
            if line.count('.') > 3: 		  # для длинных доменов
                process_domain(line[4:], list_id) # дополнительно без www
            else:		    		  # а в случае коротких
                line = line[4:]	    		  # www отрезаем всегда
        process_domain(line, list_id)


def main():
    u"""выбираем что печатаем - список доменов или stdin/другой файл"""
    list_id = 0
    assert len(argv) > 1 and path.exists(argv[1])
    domain_block = argv[1]
    if len(argv) > 2 and argv[2].isdigit():
        list_id = int(argv[2])
    process_domain_list(open(domain_block), list_id)

if __name__ == '__main__':
    main()
