#!/bin/bash

. /etc/init.d/functions
. /usr/local/Reductor/etc/const
. $CONFIG
. $MENULIB

update() {
	local var="$1"
	local value="$2"
	eval $var=\"$value\"
}


check_dns() {
	local ip_conf="$1"
	local dns_conf="$2"
	local ip_real="$3"
	local dns_rule_real="$4"
	$SETCOLOR_NORMAL
	echo "# Тестируем ip_conf=$1 dns_conf=$2 ip_real=$3 dns_rule_real=$4"
	update filter['dns'] "$dns_conf"
	update filter['dns_ip'] "$ip_conf"
	save_and_exit
	. $CONFIG
	grep filter.*dns $CONFIG | grep -v widget | grep -v log_level
	service reductor restart &>/dev/null
	echo dns="${filter['dns']}" dns_ip="${filter['dns_ip']}"
	if [ "$dns_rule_real" = '1' ]; then
		iptables -nvL FORWARD | grep -q dns && $SETCOLOR_SUCCESS || $SETCOLOR_FAILURE
		echo "Наличие цепочки в файрволе"
		iptables -nvL dns | grep -q "$ip_real" && $SETCOLOR_SUCCESS || $SETCOLOR_FAILURE
		echo "IP редиректа"
	else
		iptables -nvL FORWARD | grep -q dns && $SETCOLOR_FAILURE || $SETCOLOR_SUCCESS
		echo "Отсутствие цепочки в файрволе"
	fi
	$SETCOLOR_NORMAL
	echo
}

main() {
	local REMOTE_IP=10.50.140.73
	check_dns "" 0 "" 0					# всё отключено, ip стёрт, не работаем
	check_dns 127.0.0.1 0 $CARBONSOFT_BLACKHOLE 1		# дефолтные старые настройки - настраиваем наш blackhole
	check_dns $REMOTE_IP 0 "" 0				# свой ip, отключено, тогда не работаем
	check_dns "" 1 $CARBONSOFT_BLACKHOLE 1			# нет ip, опция включена - настраиваем на наш blackhole
	check_dns 127.0.0.1 1 $CARBONSOFT_BLACKHOLE 1		# 127.0.0.1 и включено - редиректим на localhost, это не совсем ок и надо ругаться WARNING'ами
	check_dns $REMOTE_IP 1 $REMOTE_IP 1				# указали свой ip, включили - работаем на указанный свой ip
}

main "$@"
