#!/bin/bash

set -eu

MAINDIR=/usr/local/Reductor

set_as_bad() {
	local current_version
	current_version="$(rpm -q reductor | egrep -o '[0-9]{3}-[0-9]{3}' | tr -d '-')"
	if [ -z "$current_version" -a -f "$MAINDIR/etc/version" ]; then
		read current_version < "$MAINDIR/etc/version"
	fi
	if [ -z "$current_version" -o -d "/usr/local/bad_Reductor.$current_version" ]; then
		echo "Не смогли определить текущую версию, используем date +%s"
		current_version="$(date +%s)"
	fi
	if [ -d "$MAINDIR" ]; then
		mv -v "$MAINDIR/" "/usr/local/bad_Reductor.$current_version"
	fi
}

get_latest_backup() {
	find /usr/local/ -maxdepth 2 -type d -name "old_Reductor.*" | sort -n | tail -1
}

restore() {
	mv -v "$1" "$MAINDIR/"
	service reductor restart
	service reductor check
}

main() {
	if [ "$#" -e 1 ] && [ -f "$1/userinfo/config" ]; then
			latest="$1"
	
	else
		latest="$(get_latest_backup)"
	fi

	if [ -z "$latest" ]; then
		echo "Не найдена версия для отката"
		exit 2
	fi

	set_as_bad
	restore "$latest"
}

main "$@"
