""" print ipv4 or ipv6 from resolv cache if they in https.resolv """

import os
import sys
import json
from dns_config import db_file, list_file

__author__ = 'oleg'


def __domain2ip(db, _domain, mode):
    domain = _domain.strip().decode('utf-8').encode('idna')
    domain_data = db.get(domain, {})
    return sorted(set(domain_data.get(mode, [])))

def main():
    if not os.path.isfile(db_file):
        exit(0)
    db_data = json.load(open(db_file))
    mode = 'ip6' in sys.argv and 'ip6' or 'ip'
    with open(list_file) as f:
        for domain in f.xreadlines():
            for ip in __domain2ip(db_data, domain, mode):
                print ip


if __name__ == '__main__':
    main()
