#!/bin/bash

. /usr/local/Reductor/etc/const
. $MAINDIR/usr/share/angel_lib
. $CONFIG

find_all_br() {
	ip l | grep br[0-9]*: | cut -d ':' -f2 | tr -d ' '
}

get_bridge_slave() {
	while read bridge; do
		brctl show $bridge | awk '{print $4}' | tail -n +2
	done | grep -v "^$"
}

have_ip() {
	while read device; do
		if ! ip a s $device | grep -qw inet; then
			log "Нет ip адреса на $device"
			return 2
		fi
	done
}

check() {
	[ "${misc['skipnetworkcheck']}" = '1' ] && return 0
	ip link | grep -q br[0-9] || return 1
	find_all_br | get_bridge_slave | have_ip
}

error() {
	log "Отсутствует настроенный bridge-интерфейс"
}

main_critical
